#!/usr/bin/perl

#
# $Copyright: Copyright (c) 2014 Symantec Corporation.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
# The Licensed Software and Documentation are deemed to be commercial
# computer software as defined in FAR 12.212 and subject to restricted
# rights as defined in FAR Section 52.227-19 "Commercial Computer
# Software - Restricted Rights" and DFARS 227.7202, "Rights in
# Commercial Computer Software or Commercial Computer Software
# Documentation", as applicable, and any successor regulations. Any use,
# modification, reproduction release, performance, display or disclosure
# of the Licensed Software and Documentation by the U.S. Government
# shall be solely in accordance with the terms of this Agreement.  $
#
# $Id: configGen.pl,v 1.3 2012/05/10 17:14:05 pkulkar4 Exp $
#

use strict;
use warnings;

my $conf_dir = "/opt/VRTSvcs/portal/admin/conf";
my $backup_dir = "/opt/VRTSvcs/portal/admin/conf/backup";

#print "Conf dir: [$conf_dir]\n";
`mkdir -p $backup_dir`;

# Generate Supported Application cf file
my $appcf = "$conf_dir/supportedApp.conf";

if ( -e $appcf ) {
	print "Saving existing $appcf\n";
	`mv $appcf $backup_dir`;
}
`cat $conf_dir/app_config/*.conf > $appcf`;

# Generate Descriptive Name String cf file
my $strcf = "$conf_dir/resName.mf";

if ( -e $strcf ) {
	print "Saving existing $strcf\n";
	`mv $strcf $backup_dir`;
}
`cat $conf_dir/app_config/*.mf > $strcf`;

exit 0;
