#
# $Copyright: Copyright (c) 2014 Symantec Corporation.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
# The Licensed Software and Documentation are deemed to be commercial
# computer software as defined in FAR 12.212 and subject to restricted
# rights as defined in FAR Section 52.227-19 "Commercial Computer
# Software - Restricted Rights" and DFARS 227.7202, "Rights in
# Commercial Computer Software or Commercial Computer Software
# Documentation", as applicable, and any successor regulations. Any use,
# modification, reproduction release, performance, display or disclosure
# of the Licensed Software and Documentation by the U.S. Government
# shall be solely in accordance with the terms of this Agreement.  $
#
package CPIP;
use strict;
@CPIP::ISA = qw(Obj);

sub init {
    my $self=shift;
    $self->pre_init;
    $self->init_common;
    $self->init_plat;
    $self->init_padv;
    $self->post_init;
    return;
}

sub pre_init { }
sub init_common { }
sub init_plat { }
sub init_padv { }
sub post_init { }

sub padv { return Obj::padv($_[0]->{padv}); }

sub rel { return Obj::rel($_[0]->{padv}); }

sub prod { return Obj::prod($_[1], $_[0]->{padv}, $_[2]); } # $donotdie arg

sub pkg { return Obj::pkg($_[1], $_[0]->{padv}, $_[2]); } # $donotdie arg

sub proc { return Obj::proc($_[1], $_[0]->{padv}); }

sub patch { return Obj::patch($_[1], $_[0]->{padv}); }

sub set_value {
    my $obj=shift;
    Obj::set_value($obj->{pool}, @_);
    Thr::setq($obj->{pool}, @_) if (EDR::thread_support());
    return;
}

# fallback for previously defined Rel and Prod subs
sub default_systemnames { return $_[0]->localsysname }

sub traceconf {
    my %trace;
    my $cpip_resume_subs=[];

    $trace{trace_modules} = [qw(MYCPIC CPIC CPIP Cfg EDR EEB Padv Patch Pkg Proc Prod Rel Web)];
    $trace{trace_subs}    = [qw()];
    $trace{notrace_subs} = [
        qw( Cfg::init Cfg::opt Cfg::swap_passwords
          EDR::abs_path EDR::local_windows EDR::thread_support EDR::cmdfile
          EDR::get EDR::get2 CPIC::get CPIC::get2
          Padv::inherit_uplevel Padv::plat
          Sys::pkg Sys::proc Sys::prod Sys::rel Sys::system1
          )];

    #$trace{resume_re}=qr/::ask_/;

    $cpip_resume_subs=&cpip_resume_subs() if (defined &cpip_resume_subs);

    $trace{resume_subs} = [
        qw(
          CPIC::install_useragreement
          CPIC::options
          CPIC::systems
          CPIC::upgrade_useragreement
          CPIC::set_pkgs
          CPIC::shutdown
          CPIC::uninstall
          CPIC::install
          CPIC::licensing
          CPIC::prestart_config
          CPIC::startup
          CPIC::poststart_config
          CPIC::completion
          Prod::cli_prestart_config_questions
          ),
          @{$cpip_resume_subs} ];

    return \%trace;
}

1;
